#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=beta
#AutoIt3Wrapper_icon=screenshooter.ico
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=ScreenShooter
#AutoIt3Wrapper_Res_Fileversion=0.8.0.0
#AutoIt3Wrapper_Res_LegalCopyright=2010 Michael Michta (http://michtatools.googlecode.com)
#AutoIt3Wrapper_Res_SaveSource=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#NoAutoIt3Execute
;Includes and options
#include <ScreenCapture.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#Include"_HotKey.au3"
Opt("TrayMenuMode", 3)
Opt("TrayOnEventMode", 1)

;Build Tray Menu
TrayCreateItem("Options")
TrayItemSetOnEvent(-1, "TrayOptions")
TrayCreateItem("Exit")
TrayItemSetOnEvent(-1, "TrayExit")

;Read Options From ini
Global $Opt_SavePath = IniRead("Screenshooter.ini", "Main", "SavePath", ".\SS")
Global $Opt_HotKey = IniRead("Screenshooter.ini", "Main", "HotKey", "{Media_Next}")
If $Opt_SavePath=".\SS" then DirCreate(".\SS")
;Assign HotKey
HotKeySet($Opt_HotKey, "DoSS")


;Main Loop
While 1
	Sleep(100)
WEnd


;Tray Functions
Func TrayOptions()

;Disable hotkey while GUI is open
HotKeySet($Opt_HotKey)

;Build the GUI
$Form = GUICreate("ScreenShooter (Options)", 313, 170)
GUICtrlCreateGroup("", 8, 1, 297, 129)
GUICtrlCreateLabel("Save Folder:", 16, 16, 64, 17)
$InputSavePath = GUICtrlCreateInput("", 16, 32, 233, 21, BitOR($ES_CENTER,$ES_AUTOHSCROLL))
GUICtrlCreateLabel("HotKey", 16, 56, 39, 17)
$ButtonBrowse = GUICtrlCreateButton("Browse", 248, 32, 51, 21, $WS_GROUP)
GUICtrlSetFont(-1, 6, 400, 0, "MS Sans Serif")
$ButtonChange = GUICtrlCreateButton("Change", 248, 71, 51, 21, $WS_GROUP)
GUICtrlSetFont(-1, 6, 400, 0, "MS Sans Serif")
GUICtrlCreateLabel("ScreenShooter V0.7 2009 Michael Michta", 8, 112, 295, 17, $SS_CENTER)
$InputHotKey = GUICtrlCreateInput("", 16, 72, 233, 21, BitOR($ES_CENTER,$ES_AUTOHSCROLL,$ES_READONLY))
GUICtrlCreateGroup("", -99, -99, 1, 1)
$ButtonOK = GUICtrlCreateButton("OK", 65, 139, 75, 25, $WS_GROUP)
$ButtonCancel = GUICtrlCreateButton("Cancel", 162, 139, 75, 25, $WS_GROUP)

;Set inputboxes from global vars
GuiCtrlSetData($InputSavePath,$Opt_SavePath)
GuiCtrlSetData($InputHotKey,_HotKeyToString($Opt_HotKey))

;Show The GUI
GUISetState(@SW_SHOW)

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE,$ButtonCancel
			GuiDelete()
			Return
		Case $ButtonOK

			;Read data from input boxes
			$SavePath=GuiCtrlRead($InputSavePath)
			$HotKey=GuiCtrlRead($InputHotKey)

			;Display an error if the save folder does not exist or is not a directory
			If Not (FileExists($SavePath) and StringInStr(FileGetAttrib($SavePath),"D")) Then
				MsgBox(0,"Error",'"'&$SavePath&'" does not exist or is not a directory.',default,$Form)
				ContinueLoop
			EndIf
			;Assign global vars
			$Opt_HotKey=_StringToHotKey($HotKey)
			$Opt_SavePath=$SavePath

			;Write config data to ini
			IniWrite("Screenshooter.ini", "Main", "SavePath",$Opt_SavePath)
			IniWrite("Screenshooter.ini", "Main", "HotKey",$Opt_HotKey)

			;Set Hotkey
			HotKeySet($Opt_HotKey,"DoSS")

			;Delete GUI and Return
			GuiDelete()
			Return
		Case $ButtonBrowse
			;Allow the user to select a folder with dialog
			$Folder=FileSelectFolder("Folder?","",3,GuiCtrlRead($Opt_SavePath),$Form)
			If Not @Error then GuiCtrlSetData($InputSavePath,$Folder)
		Case $ButtonChange
			;Allow the user to select a hotkey with dialog
			$HK= _ChooseHotKey(_StringToHotKey(GuiCtrlRead($InputHotKey)),0,'Choose HotKey',Default,Default,Default,Default,$Form)
			If Not @Error then GuiCtrlSetData($InputHotKey,_HotKeyToString($HK))
	EndSwitch
WEnd

EndFunc   ;==>TrayOptions
Func TrayExit()
	Exit
EndFunc   ;==>TrayExit

;Screenshot function
Func DoSS()
	;Capture screenshot
	_ScreenCapture_Capture($Opt_SavePath & "\" & @YDAY & "_" &  @HOUR & "_" & @MIN & "_" & @SEC & ".png")
EndFunc   ;==>DoSS
